/* @(#)StepSizeDialog.java
*
* vfstagecontroller java package: A simple way to drive a microscope serial
* controlled stage.
* Copyright 2003(C) Policlinico Universitario di Udine
* Written by: Federico Viel
            vielfede@libero.it

* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.

* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software Foundation,
* Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package vfstagecontroller;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: StepSizeDialog</p>
 * <p>Description: A simple dialog to set stage step sizes. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Policlinico Universitario di Udine</p>
 * @author Federico Viel
 * @version 1.0
 */

public class StepSizeDialog extends Dialog{
  private Button ok_button = new Button();
  private Button cancel_button = new Button();
  private Label labelx=new Label("Step size x");
  private Label labely=new Label("Step size y");
  private Label labelz=new Label("Step size z");
  private TextField tfieldx=new TextField("");
  private TextField tfieldy=new TextField("");
  private TextField tfieldz=new TextField("");

  public boolean status;

  public StepSizeDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
     initDialog();

  }

  public StepSizeDialog(Frame frame) {
    this(frame, "", false);
  }

  public StepSizeDialog(Frame frame, boolean modal) {
    this(frame, "", modal);
  }

  public StepSizeDialog(Frame frame, String title) {
    this(frame, title, false);
  }
  private void initDialog(){
    labelx.setText("Step size x ("+StageCommands.XYUnits+")");
    labely.setText("Step size y ("+StageCommands.XYUnits+")");
    labelz.setText("Step size z ("+StageCommands.ZUnits+")");

    labelx.setBounds(new Rectangle(20, 30, 134, 20));
    add(labelx);

    labely.setBounds(new Rectangle(20, 55, 143, 20));
    add(labely);

    labelz.setBounds(new Rectangle(20, 80, 197, 20));
    add(labelz);

    tfieldx.setBounds(new Rectangle(230, 31, 78, 20));

    tfieldy.setBounds(new Rectangle(230, 56, 78, 20));

    tfieldz.setBounds(new Rectangle(230, 81, 78, 20));

    ok_button.setLabel("OK");
    ok_button.setBounds(new Rectangle(87, 122, 77, 30));
    ok_button.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ok_button_actionPerformed(e);
      }
    });
    cancel_button.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancel_button_actionPerformed(e);
      }
    });
    cancel_button.setLabel("cancel");
    cancel_button.setBounds(new Rectangle(175, 122, 77, 30));
    this.add(cancel_button);
    this.add(ok_button);
    this.add(tfieldy);
    this.add(tfieldz);
    this.add(tfieldx);


    this.setResizable(false);
    this.setLayout(null);
    this.setSize(new Dimension(335, 180));
    Point p=this.getParent().getLocation();
    p.translate(40,100);
    this.setLocation(p);
  }


  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }
  void cancel() {
    dispose();
  }

  public void setFields(long xs, long ys, long zs){
    tfieldx.setText(String.valueOf(xs));
    tfieldy.setText(String.valueOf(ys));
    tfieldz.setText(String.valueOf(zs));
    return;
  }
  public long getXSField(){
    return Long.parseLong(tfieldx.getText());
  }
  public long getYSField(){
    return Long.parseLong(tfieldy.getText());
  }
  public long getZSField(){
    return Long.parseLong(tfieldz.getText());
  }
  void ok_button_actionPerformed(ActionEvent e) {
    status=true;
    cancel();
  }
  void cancel_button_actionPerformed(ActionEvent e) {
    cancel();
  }
}